"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Spinner = void 0;
var react_1 = __importDefault(require("react"));
var CircularProgress_1 = __importDefault(require("@mui/material/CircularProgress"));
var styles_1 = require("@mui/material/styles");
var createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
var makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
var useStyles = (0, makeStyles_1.default)(function (theme) {
    return (0, createStyles_1.default)({
        background: {
            position: 'fixed',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            zIndex: 1000,
            backgroundColor: theme.palette.mode === 'light' ? 'rgba(255,255,255,0.6)' : 'rgba(0,0,0,0.7)',
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            flexDirection: 'column',
        },
    });
});
/**
 * Component that renders a indeterminate circular progress spinner atop a semi-transparent white background.
 *
 * @param visible True if the spinner should be displayed, false to render nothing
 *
 * @category Component
 */
var Spinner = function (props) {
    var visible = props.visible;
    var theme = (0, styles_1.useTheme)();
    var classes = useStyles(theme);
    return visible ? (react_1.default.createElement("div", { className: classes.background },
        react_1.default.createElement(CircularProgress_1.default, { size: 70, variant: 'indeterminate' }))) : (react_1.default.createElement(react_1.default.Fragment, null));
};
exports.Spinner = Spinner;
