"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResetPassword = void 0;
var react_1 = __importStar(require("react"));
var react_auth_shared_1 = require("@brightlayer-ui/react-auth-shared");
var useQueryString_1 = require("../hooks/useQueryString");
var RoutingContext_1 = require("../contexts/RoutingContext");
var react_router_dom_1 = require("react-router-dom");
var Button_1 = __importDefault(require("@mui/material/Button"));
var CardActions_1 = __importDefault(require("@mui/material/CardActions"));
var CardContent_1 = __importDefault(require("@mui/material/CardContent"));
var CardHeader_1 = __importDefault(require("@mui/material/CardHeader"));
var Divider_1 = __importDefault(require("@mui/material/Divider"));
var Typography_1 = __importDefault(require("@mui/material/Typography"));
var Grid_1 = __importDefault(require("@mui/material/Grid"));
var styles_1 = require("@mui/material/styles");
var makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
var components_1 = require("../components");
var constants_1 = require("../constants");
var CheckCircle_1 = __importDefault(require("@mui/icons-material/CheckCircle"));
var Error_1 = __importDefault(require("@mui/icons-material/Error"));
var clsx_1 = __importDefault(require("clsx"));
var styles_2 = require("../styles");
var useDialogStyles = (0, makeStyles_1.default)(styles_2.sharedDialogStyles);
/**
 * Renders a screen stack which handles the reset password flow (deep link from email).
 *
 * @category Component
 */
var ResetPassword = function () {
    var _a;
    var t = (0, react_auth_shared_1.useLanguageLocale)().t;
    var navigate = (0, react_router_dom_1.useNavigate)();
    var routes = (0, RoutingContext_1.useRoutes)().routes;
    var theme = (0, styles_1.useTheme)();
    var classes = useDialogStyles();
    var accountUIState = (0, react_auth_shared_1.useAccountUIState)();
    var accountUIActions = (0, react_auth_shared_1.useAccountUIActions)();
    var _b = (0, useQueryString_1.useQueryString)(), code = _b.code, email = _b.email;
    var passwordRef = (0, react_1.useRef)(null);
    var confirmRef = (0, react_1.useRef)(null);
    // Local State
    var _c = (0, react_1.useState)(''), passwordInput = _c[0], setPasswordInput = _c[1];
    var _d = (0, react_1.useState)(''), confirmInput = _d[0], setConfirmInput = _d[1];
    var _e = (0, react_1.useState)(false), hasAcknowledgedError = _e[0], setHasAcknowledgedError = _e[1];
    // Network state (verifyResetCode)
    var verifyResetCodeTransit = accountUIState.setPassword.verifyResetCodeTransit;
    var verifyIsInTransit = verifyResetCodeTransit.transitInProgress;
    var validationTransitErrorMessage = verifyResetCodeTransit.transitErrorMessage;
    var verifySuccess = verifyResetCodeTransit.transitSuccess;
    var verifyComplete = verifyResetCodeTransit.transitComplete;
    // Network state (setPassword)
    var setPasswordTransit = accountUIState.setPassword.setPasswordTransit;
    var setPasswordTransitSuccess = setPasswordTransit.transitSuccess;
    var setPasswordIsInTransit = setPasswordTransit.transitInProgress;
    var setPasswordHasTransitError = setPasswordTransit.transitErrorMessage !== null;
    var setPasswordTransitErrorMessage = setPasswordTransit.transitErrorMessage;
    // Reset state on dismissal
    (0, react_1.useEffect)(function () { return function () {
        accountUIActions.dispatch(react_auth_shared_1.AccountActions.setPasswordReset());
        accountUIActions.dispatch(react_auth_shared_1.AccountActions.verifyResetCodeReset());
    }; }, // eslint-disable-next-line react-hooks/exhaustive-deps
    []);
    (0, react_1.useEffect)(function () {
        if (!verifyIsInTransit && !verifyComplete && code.length > 0) {
            void accountUIActions.actions.verifyResetCode(code, email);
        }
        // eslint-disable-line react-hooks/exhaustive-deps
    }, [verifyIsInTransit, code, email, verifyComplete, accountUIActions.actions]);
    var _f = (0, react_auth_shared_1.useInjectedUIContext)().passwordRequirements, passwordRequirements = _f === void 0 ? (0, constants_1.defaultPasswordRequirements)(t) : _f;
    var areValidMatchingPasswords = (0, react_1.useCallback)(function () {
        for (var i = 0; i < passwordRequirements.length; i++) {
            if (!new RegExp(passwordRequirements[i].regex).test(passwordInput))
                return false;
        }
        return confirmInput === passwordInput;
    }, [passwordRequirements, passwordInput, confirmInput]);
    var updateFields = (0, react_1.useCallback)(function (fields) {
        setPasswordInput(fields.password);
        setConfirmInput(fields.confirm);
    }, [setPasswordInput, setConfirmInput]);
    var resetPassword = (0, react_1.useCallback)(function (password) {
        void accountUIActions.actions.setPassword(code, password, email);
    }, [accountUIActions, code, email]);
    var canContinue = (0, react_1.useCallback)(function () { return areValidMatchingPasswords() && !setPasswordTransit.transitInProgress; }, [areValidMatchingPasswords, setPasswordTransit]);
    var onContinue = (0, react_1.useCallback)(function () {
        if (setPasswordTransitSuccess) {
            navigate(routes.LOGIN);
        }
        else {
            resetPassword(passwordInput);
        }
    }, [resetPassword, setPasswordTransitSuccess, passwordInput, navigate, routes]);
    var getBody = (0, react_1.useCallback)(function () {
        return verifySuccess && !verifyIsInTransit ? (setPasswordTransitSuccess ? (react_1.default.createElement(components_1.FinishState, { icon: react_1.default.createElement(CheckCircle_1.default, { color: 'primary', style: { fontSize: 100, marginBottom: theme.spacing(2) } }), title: t('blui:PASSWORD_RESET.SUCCESS_MESSAGE'), description: t('blui:CHANGE_PASSWORD.SUCCESS_MESSAGE') })) : (react_1.default.createElement(components_1.ChangePasswordForm, { passwordRef: passwordRef, confirmRef: confirmRef, passwordLabel: t('blui:LABELS.NEW_PASSWORD'), onPasswordChange: updateFields, onSubmit: canContinue() ? onContinue : undefined }))) : !verifyComplete ? (react_1.default.createElement(react_1.default.Fragment, null)) : (react_1.default.createElement(components_1.FinishState, { icon: react_1.default.createElement(Error_1.default, { color: 'error', style: { fontSize: 100, marginBottom: theme.spacing(2) } }), title: t('blui:MESSAGES.FAILURE'), description: validationTransitErrorMessage }));
    }, [
        t,
        canContinue,
        onContinue,
        theme,
        verifySuccess,
        verifyIsInTransit,
        verifyComplete,
        validationTransitErrorMessage,
        setPasswordTransitSuccess,
        updateFields,
    ]);
    var errorDialog = (react_1.default.createElement(components_1.SimpleDialog, { title: t('blui:MESSAGES.ERROR'), body: t(setPasswordTransitErrorMessage !== null && setPasswordTransitErrorMessage !== void 0 ? setPasswordTransitErrorMessage : ''), open: setPasswordHasTransitError && !hasAcknowledgedError, onClose: function () {
            setHasAcknowledgedError(true);
        } }));
    return (react_1.default.createElement(components_1.BrandedCardContainer, { loading: verifyIsInTransit || setPasswordIsInTransit },
        errorDialog,
        react_1.default.createElement(CardHeader_1.default, { title: react_1.default.createElement(Typography_1.default, { variant: 'h6', style: { fontWeight: 600 } }, t('blui:FORMS.RESET_PASSWORD')), className: classes.dialogTitle }),
        react_1.default.createElement(CardContent_1.default, { className: classes.dialogContent }, getBody()),
        react_1.default.createElement(Divider_1.default, null),
        react_1.default.createElement(CardActions_1.default, { className: classes.dialogActions },
            react_1.default.createElement(Grid_1.default, { container: true, direction: "row", alignItems: "center", justifyContent: "space-between", style: { width: '100%' } },
                !setPasswordTransitSuccess && (react_1.default.createElement(Button_1.default, { variant: "outlined", color: "primary", onClick: function () { return navigate(routes.LOGIN); }, className: classes.dialogButton }, t('blui:ACTIONS.BACK'))),
                verifySuccess && (react_1.default.createElement(Button_1.default, { variant: "contained", disableElevation: true, disabled: !canContinue(), color: "primary", onClick: onContinue, className: (0, clsx_1.default)(classes.dialogButton, (_a = {}, _a[classes.fullWidth] = setPasswordTransitSuccess, _a)) }, setPasswordTransitSuccess ? t('blui:ACTIONS.DONE') : t('blui:ACTIONS.OKAY')))))));
};
exports.ResetPassword = ResetPassword;
