"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Splash = void 0;
var react_1 = __importDefault(require("react"));
var CardContent_1 = __importDefault(require("@mui/material/CardContent"));
var styles_1 = require("@mui/material/styles");
var createStyles_1 = __importDefault(require("@mui/styles/createStyles"));
var makeStyles_1 = __importDefault(require("@mui/styles/makeStyles"));
var components_1 = require("../components");
var CircularProgress_1 = __importDefault(require("@mui/material/CircularProgress"));
var useStyles = (0, makeStyles_1.default)(function () {
    return (0, createStyles_1.default)({
        content: {
            flex: '1 1 0px',
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'center',
            flexDirection: 'column',
        },
        image: {
            maxWidth: '100%',
            maxHeight: 80,
        },
    });
});
/**
 * Renders the splash screen displayed while loading the initial
 * authentication state.
 *
 * @param mainImage the product logo or image to use on the loading screen
 *
 * @category Component
 */
var Splash = function (props) {
    var mainImage = props.mainImage;
    var theme = (0, styles_1.useTheme)();
    var classes = useStyles();
    return (react_1.default.createElement(components_1.BrandedCardContainer, null,
        react_1.default.createElement(CardContent_1.default, { className: classes.content },
            mainImage && (react_1.default.createElement("div", { style: { paddingBottom: theme.spacing(6) } },
                react_1.default.createElement("img", { src: "".concat(mainImage), className: classes.image, alt: "product logo" }))),
            react_1.default.createElement(CircularProgress_1.default, { size: mainImage ? 40 : 70, variant: 'indeterminate' }))));
};
exports.Splash = Splash;
